/* Format for an object file and loadable image */

/* Magic numbers */
#define	OMAGIC		0x100	/* This is an obj file, not link edited yet */
#define	BOBJ		0x80	/* Down loadable binary */

struct format {
	short	f_magic;	/* Magic number */
	short	f_laddr;	/* Load address */
	short	f_saddr;	/* Start address */
	short	f_csiz;		/* Size (in bytes) of executable */
};

/* Max size of an identifier */
#define	IDENTSIZ	6

struct symbol {
	char	s_symnm[IDENTSIZ];		/* Symbol name */
	short	s_flags;			/* Flags from st_type */
	short	s_raddr;			/* Resolution address */
	short	s_naddr;			/* Addresses to 16-bit patch */
};
