#include "TIasm.h"
#include <stdio.h>

/* adrinf
 *
 * Add an address to be relocated in to the list in the symbol table entry
 * reserved for just such a purpose.
 *
 * RETURNS:
 *	nothing
 *
 * NOTE: May abort if the malloc fails.
 */

void adrinf (stab, loc)
struct stab *stab;
short	loc;
{
	struct a_lst *ainfo;
	extern char *malloc();

	if ((ainfo = (struct a_lst *)malloc(sizeof(struct a_lst))) == NULL)
		aabort ("adrinf: no mem!");
	ainfo->a_addr = loc;
	ainfo->a_next = stab->en_lst;
	stab->en_lst = ainfo;
}
